/*

  display doscall name, arguments, result code
  ( called from New_handler )

  Copyright (C) 1991 K.Abe

*/

#define CSRX (unsigned short *)(0x974)

#include <stdio.h>
#include <unistd.h>
#include "trace.h"
#include "error.inc"

extern void display2( int , int );
static void indent( void );

static char	*Formatted_string;
static int	Flush_flag = 1;
static int	Doscall_nestlevel = 0;
static int	Last_instruction_not_return = 0;

extern void	display1( int callnum , void *arg )
{
    callnum &= 0xff;

    if( Flush_flag == 0 ) {
	display2( 0 , 1 );
	Doscall_nestlevel++;
    }
    Formatted_string = Format_output( callnum , arg );
    Flush_flag = 0;
    Count++;
    if( callnum == 0 || callnum == 0x4c || callnum == 0x31 ) {
	Last_instruction_not_return = 1;
	Doscall_nestlevel--;
    } else
	Last_instruction_not_return = 0;

    /* [ɏo͂ꍇ́ADOS Call {̎sOɃtbV */
    if( isatty( fileno( Stream ) ) )
	fflush( Stream );
}


extern void display2( int result , int result_unknown )
{

    if( isatty( fileno( Stream ) ) )
    {
	fflush( Stream );
	if( *CSRX != 0 )
	    putc( '\n' , Stream );
    }

    if( Flush_flag )
	Doscall_nestlevel--;

    indent();
    if( Flush_flag )
	putc( '}' , Stream );
    else
	fputs( Formatted_string , Stream );

    putc( '=' , Stream );
    if( result_unknown ) {
	if( Last_instruction_not_return )
	    putc( '?' , Stream );
	else
	    putc( '{' , Stream );
    } else {
	fprintf( Stream , "%d" , result );
	if( (unsigned long)result >= 10 )
	    fprintf( Stream , "(0x%x)" , result );
	if( result < 0 )
	{
	    if( result == -80 )
		result = 0;
	    if( ERROR_NUMBER_MIN <= result )
		fprintf( Stream , "(%s)" , Human_error_message[ -result ] );
//		fprintf( Stream , "(%s)" , Human_error_message[ -( result == -80 ? 0 : result ) ] );
	}
    }

    putc( '\n' , Stream );
    Flush_flag = 1;
}


static void	indent()
{
    int	i;
    for( i = 0 ; i < Doscall_nestlevel ; i++ ) {
	putc( ' ' , Stream );
	putc( ' ' , Stream );
    }
}
