* sub.s  for trace.x  by Tachibana Eriko

* Include File -------------------------------- *

		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xdef	_usage
		.xdef	_version_error
		.xdef	_error_exit
		.xref	__iob
		.xref	_fprintf
		.xref	_exit

		.xdef	_setup_doscall_handler
		.xdef	_restore_doscall_handler
		.xref	_New_handler
		.xref	_Old_handler


* Fixed Number -------------------------------- *

LF:		.equ	10
FLINE_TRAP_VEC:	.equ	11

stderr:		.reg	__iob+36*2

* Text Section -------------------------------- *

		.text
		.even

* extern void usage( void );

_usage:
		pea	(usage_message,pc)
		bsr	_error_exit

* extern void version_error( void );

_version_error:
		pea	(version_error_message,pc)
		bsr	_error_exit

* extern void error_exit( const char *format );

_error_exit:
		move.l	#stderr,(sp)
		jsr	_fprintf
		pea	(1)
		jsr	_exit

* extern void setup_doscall_handler( void );

_setup_doscall_handler:
		lea	(_New_handler,pc),a1
		bsr	intvcs_fline
		move.l	d0,(_Old_handler)
		rts

* extern void restore_doscall_handler( void );

_restore_doscall_handler:
		movea.l	(_Old_handler),a1
intvcs_fline:
		move	#FLINE_TRAP_VEC,d1
		IOCS	_B_INTVCS
		rts

*		.data

usage_message:
		.dc.b	'DOS call tracer version 0.1+1 Copyright (C)1991,1995 K.Abe,Eriko',LF
		.dc.b	'usage: trace [-o file] command arg ...',LF,0
version_error_message:
		.dc.b	'trace: this version of human68k is not supported.',LF,0


		.even

* End of Source ------------------------------- *

		.end
